// ======================================================================
//
// HardPoints.h
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef HARD_POINTS_H
#define HARD_POINTS_H

// ======================================================================

class Appear;
class Iff;

#include "Xform.h"

// ======================================================================

class HardPoints
{
private:

	class Entry
	{
	private:

		Xform   xform;
		char   *name;

	public:

		Entry(void);
		~Entry(void);	

		void   setName(char *newName);
		void   setXform(const Xform &newXform);

		const Xform &getXform(void) const;
		const char  *getName(void) const;
	};

private:

	int     users;
	int     count;
	Entry  *entry;

private:

	HardPoints(void);
	HardPoints(const HardPoints &);
	HardPoints &operator =(const HardPoints &);

public:

	static void addUser(HardPoints *hp);
	static void removeUser(HardPoints *hp);
	
	HardPoints(Iff &iff, const char *id);
	~HardPoints(void);

	int           getCount(void) const;

	bool          findName(const char *name, int *index) const;

	const char   *getName(int hp) const;
	const Xform  &getXform(int hp) const;

	void render(void) const;
};

// ======================================================================

inline void HardPoints::Entry::setName(char *newName)
{
	name = newName;
}

// ----------------------------------------------------------------------

inline void HardPoints::Entry::setXform(const Xform &newXform)
{
	xform = newXform;
}

// ----------------------------------------------------------------------

inline const Xform &HardPoints::Entry::getXform(void) const
{
	return xform;
}

// ----------------------------------------------------------------------

inline const char *HardPoints::Entry::getName(void) const
{
	return name;
}

// ======================================================================

inline void HardPoints::addUser(HardPoints *hp)
{
	if (hp)
		hp->users++;
}

// ----------------------------------------------------------------------

inline void HardPoints::removeUser(HardPoints *hp)
{
	if (hp && --hp->users == 0)
		delete hp;
}

// ----------------------------------------------------------------------

inline int HardPoints::getCount(void) const
{
	return count;
}

// ----------------------------------------------------------------------

inline const char *HardPoints::getName(int hp) const
{
	return entry[hp].getName();
}

// ----------------------------------------------------------------------

inline const Xform &HardPoints::getXform(int hp) const
{
	return entry[hp].getXform();
}

// ======================================================================

#endif
